#include <iostream>
using namespace std;

#define MAX 10

int enfileirar(int v[], int &fim, int &num, int valor);
int desenfileirar(int v[], int &ini, int fim, int &num, int &valor);

int main(void) {
    // Declara a fila
    int fila[MAX];
    int ini = 0;
    int fim = -1;
    int nfila = 0;

    // Varivel para armazenar dado digitado
    int dado, dado2;
    // Varivel que indica se acabaram valores da fila
    int vazia;

    // L valores e os enfileira, se forem >= 0
    do {
        cout << "Digite um numero inteiro a enfileirar (0 desenfileira um nmero, -1 termina): ";
        cin >> dado;
        if (dado >0) enfileirar(fila, fim, nfila, dado);
        else if(dado==0) desenfileirar(fila, ini, fim, nfila, dado2);
        } while(dado >= 0);

    // Agora mostra valores da pilha at que eles acabem...
    while ( desenfileirar(fila, ini, fim, nfila, dado) == 0 ) {
        cout << dado << endl;
    	}
}

// Enfileira um valor
// Entrada:
//  v: vetor com elementos da fila
//  fim: fim da fila
//  num: nmero de elementos atuais
//  valor: valor a ser enfileirado
// Retorna:
//  1- Se fila cheia
//  0- Caso contrrio
int enfileirar(int v[], int &fim, int &num, int valor) {
    // Se a fila est cheia... retorna 1
    if (num==MAX) {
        cout << "ERRO: Fila cheia!" << endl;
        return 1;
    }
    // Se fila no est cheia, vamos enfileirar
    fim = fim + 1;
    if (fim>=MAX) fim = fim - MAX;
    v[fim] = valor;
    num = num + 1;
    // Indica que valor foi enfileirado
    return 0;
}


// Desenfileira um valor
// Entrada:
//  v: vetor com elementos da fila
//  ini: inicio da fila
//  fim: final da fila
//  num: nmero de elementos atuais
//  valor: Local a colocar valor desenfileirado
// Retorna:
//  valor: valor desenfileirado
//  1- Se fila vazia
//  0- Caso contrrio
int desenfileirar(int v[], int &ini, int fim, int &num, int &valor) {
    // Se a fila est vazia... retorna 1
    if (num == 0) {
        cout << "ERRO: Fila vazia!" << endl;
        return 1;
    }
    // Se fila no est vazia, vamos desenfileirar
    valor = v[ini];
    ini = ini + 1;
    if (ini >= MAX) ini = ini - MAX;
    num = num - 1;
    // Indica que valor foi desenfileirado
    return 0;
}


